/* 
 * $Author:$
 * 
 * $Id:$
 * 
 */

/*--------------------------------------------------------------------------
 * Low level access routines for the Philips SJA1000 CAN device.
 *--------------------------------------------------------------------------*/
 
/* Define to whatever you will use to print formatted strings,
 * or leave this empty, to disable all prints.
 * 
 * #define PRINTF(x)	printf x
 */

#define PRINTF(x)		uprintf x

/*
 * Makros for low level access.
 */
#define CAN_CTRLIN		PINB
#define CAN_ADATAIN		PIND
#define CAN_CTRLOUT		PORTB
#define CAN_ADATAOUT	PORTD

#define CAN_ALE			(PORTD & BIT3)
#define CAN_WR			(PORTD & BIT6)
#define CAN_RD			(PORTD & BIT5)
#define CAN_ADDR		CAN_CTRLOUT = (LEV) ? (CAN_CTRLIN & ~CAN_ALE):(CAN_CTRLIN | CAN_ALE)
#define CAN_WRITE		CAN_CTRLOUT = (LEV) ? (CAN_CTRLIN & ~CAN_WR):(CAN_CTRLIN | CAN_WR)
#define CAN_ADDR		CAN_CTRLOUT = (LEV) ? (CAN_CTRLIN & ~CAN_RD):(CAN_CTRLIN | CAN_RD)

extern inline void
can_ll_write(unsigned char address, unsigned char data)
{
	CAN_WRITE(1);
	CAN_READ(1);
	CAN_ADDR(1);
	CAN_ADATAOUT = address;
	CAN_ADDR(0);

	CAN_WRITE(0);
	CAN_ADATAOUT = data;
	CAN_WRITE(1);
}

extern inline unsigned char
can_ll_read(unsigned char address)
{
	CAN_WRITE(1);
	CAN_READ(1);
	CAN_ADDR(1);
	CAN_ADATAOUT = address;
	CAN_ADDR(0);

	CAN_READ(0);
	CAN_ADATAOUT = data;
	CAN_READ(1);

	return CAN_ADATAIN;
}

extern inline void
can_ll_eint(void)
{
	/* Dow what ever neccessary to enable the ext. Interrupt for the
	 * SJA1000 CAN device
	 */
}

extern inline void
can_ll_dint(void)
{
	/* Dow what ever neccessary to disable the ext. Interrupt for the
	 * SJA1000 CAN device
	 */
}

extern inline void
can_ll_init(void)
{
	/* Initialise Ports and what ever neccessary to your needs... */
}
